/**
*     Copyright (c) 2022, Nsing Technologies Pte. Ltd.
*
*     All rights reserved.
*
*     This software is the exclusive property of Nsing Technologies Pte. Ltd. (Hereinafter
* referred to as Nsing). This software, and the product of Nsing described herein
* (Hereinafter referred to as the Product) are owned by Nsing under the laws and treaties
* of the People’s Republic of China and other applicable jurisdictions worldwide.
*
*     Nsing does not grant any license under its patents, copyrights, trademarks, or other
* intellectual property rights. Names and brands of third party may be mentioned or referred
* thereto (if any) for identification purposes only.
*
*     Nsing reserves the right to make changes, corrections, enhancements, modifications, and
* improvements to this software at any time without notice. Please contact Nsing and obtain
* the latest version of this software before placing orders.

*     Although Nsing has attempted to provide accurate and reliable information, Nsing assumes
* no responsibility for the accuracy and reliability of this software.
*
*     It is the responsibility of the user of this software to properly design, program, and test
* the functionality and safety of any application made of this information and any resulting product.
* In no event shall Nsing be liable for any direct, indirect, incidental, special,exemplary, or
* consequential damages arising in any way out of the use of this software or the Product.
*
*     Nsing Products are neither intended nor warranted for usage in systems or equipment, any
* malfunction or failure of which may cause loss of human life, bodily injury or severe property
* damage. Such applications are deemed, “Insecure Usage”.
*
*     All Insecure Usage shall be made at user’s risk. User shall indemnify Nsing and hold Nsing
* harmless from and against all claims, costs, damages, and other liabilities, arising from or related
* to any customer’s Insecure Usage.

*     Any express or implied warranty with regard to this software or the Product, including,but not
* limited to, the warranties of merchantability, fitness for a particular purpose and non-infringement
* are disclaimed to the fullest extent permitted by law.

*     Unless otherwise explicitly permitted by Nsing, anyone may not duplicate, modify, transcribe
* or otherwise distribute this software for any purposes, in whole or in part.
*
*     Nsing products and technologies shall not be used for or incorporated into any products or systems
* whose manufacture, use, or sale is prohibited under any applicable domestic or foreign laws or regulations.
* User shall comply with any applicable export control laws and regulations promulgated and administered by
* the governments of any countries asserting jurisdiction over the parties or transactions.
**/

/**
 *\*\file n32g401_wwdg.h
 *\*\author Nsing
 *\*\version v1.0.0
 *\*\copyright Copyright (c) 2022, Nsing Technologies Pte. Ltd. All rights reserved.
 **/

#ifndef __N32G401_WWDG_H__
#define __N32G401_WWDG_H__

#ifdef __cplusplus
extern "C"
{
#endif

#include "n32g401.h"

#define WWDG_PRESCALER_DIV1 ((uint32_t)0x00000000)
#define WWDG_PRESCALER_DIV2 ((uint32_t)WWDG_CFG_TIMERB0)
#define WWDG_PRESCALER_DIV4 ((uint32_t)WWDG_CFG_TIMERB1)
#define WWDG_PRESCALER_DIV8 ((uint32_t)(WWDG_CFG_TIMERB1 | WWDG_CFG_TIMERB0))

/** WWDG registers bit address in the alias region **/
#define WWDG_OFFADDR (WWDG_BASE - PERIPH_BASE)

/** Alias word address of EWINT bit **/
#define CFG_OFFADDR (WWDG_OFFADDR + 0x04)
#define EWINT_BIT (0x10)
#define CFG_EWINT_BB (PERIPH_BB_BASE + (CFG_OFFADDR * 32) + (EWINT_BIT * 4))

/** CTRL register bit mask **/
#define CTRL_ACTB_SET ((uint32_t)WWDG_CTRL_ACTB)

/* CFG register bit mask **/
#define CFG_TIMERB_MASK ((uint32_t)0xFFFF3FFF)
#define CFG_W_MASK ((uint32_t)0xFFFFC000)
#define BIT_MASK ((uint16_t)0x3FFF)

    void WWDG_Reset(void);
    void WWDG_Prescaler_Division_Set(uint32_t prescaler_division);
    void WWDG_Window_Value_Set(uint16_t window_value);
    void WWDG_Interrupt_Enable(void);
    void WWDG_Counter_Value_Set(uint16_t counter_value);
    void WWDG_Enable(uint16_t counter_value);
    FlagStatus WWDG_EWINTF_Flag_Get(void);
    void WWDG_EWINTF_Flag_Clear(void);

#ifdef __cplusplus
}
#endif

#endif /* __N32G401_WWDG_H__ */
